<template>
    <f7-page name="panicgroupform" @page:beforein="onPageBeforeIn" @page:beforeout="onPageBeforeOut">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large>
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">Tombol Panik</f7-nav-title>
            <f7-nav-title-large>{{ formType }} Tombol Panik</f7-nav-title-large>
		</f7-navbar>

        <f7-list id="panic-group" media-list no-hairlines>
            <f7-list-item>
                <div slot="media" class="img-uploader" @click="handleUpload()">
                    <img v-if="media != null" :src="media.url.small" width="88" class="img-circle">
				    <img v-else :src="require('../assets/no-group-photo.png')" width="88" class="img-circle">
                </div>
                <div slot="title" class="display-block">
                    <input type="text" name="name" placeholder="Nama tombol panik" :value="groupForm.name" @input="groupForm.name = $event.target.value" >
                </div>
                <div slot="subtitle">
                    <input type="text" name="description" placeholder="Deskripsi" :value="groupForm.description" @input="groupForm.description = $event.target.value" >
                </div>
            </f7-list-item>
        </f7-list>
        <f7-block style="text-align: justify;padding:20px;border-radius:7px;" class="gradient-cyan">
            <p>Guna melindungi data pengguna. Nama yang kami tampilkan adalah kode acak. Setelah mendapatkan persetujuan dari pengguna, nama dan foto pengguna sebenarnya akan tampil secara otomatis.</p>
        </f7-block>
        <f7-block>
            <f7-list no-hairlines class="no-margin-top">
                <f7-list-item 
                    title="Group" 
                    smart-select
                    :smart-select-params="{'closeOnSelect': true}">
                    <select 
                        name="panic_group"
                        :value="groupForm.panic_group"
                        @change="groupForm.panic_group = $event.target.value">
                        <option value="community" selected>Komunitas</option>
                        <option value="family">Keluarga</option>
                        <option value="friendship">Pertemanan</option>
                        <option value="work">Pekerjaan</option>
                        <option value="residential">Perumahan</option>
                    </select>
                </f7-list-item>
                <f7-list-item>
                    <div class="item-title">Gunakan Live Location?</div>
                    <f7-toggle 
                        color="blue"
                        :value="1"
                        :checked="groupForm.live_location"
                        @toggleChange="handleLive($event)"></f7-toggle>
                </f7-list-item>							
                <f7-list-item
                    link
                    title="Tambah Anggota"
                    popup-open=".participant-popup"
                >
                </f7-list-item>
                <f7-popup @popup:opened="participantPopupOpen" @popup:closed="participantPopupClose($event)" class="participant-popup">
                    <f7-view>
                        <f7-page>
                            <f7-navbar>
                                <f7-nav-left>
                                    <f7-link icon-f7="arrow_left" popup-close=".participant-popup"></f7-link>
                                </f7-nav-left>
                                <f7-nav-title>Cari Anggota</f7-nav-title>
                                <f7-subnavbar :inner="false">
                                    <f7-searchbar
                                        custom-search 
                                        @searchbar:search="handleParticipantSearch"
                                        :disable-button="false"
                                        placeholder="Ketik No. Handphone"
                                        :clear-button="true"
                                    ></f7-searchbar>
                                </f7-subnavbar>
                            </f7-navbar>
                    
                            <f7-block v-if="participant != null">
                                <f7-list media-list no-hairlines>
                                    <f7-list-item
                                        link
                                        @click="addParticipant(participant)"
                                    >
                                        <div slot="title">{{ randomName() }}</div>
                                        <div slot="subtitle" style="letter-spacing: 14px;">{{ participant.phone.substr(participant.phone.length - 4) }}</div>
                                        <img :src="require('../assets/no-profile-photo.png')" width="48" height="48" class="img-circle" slot="media"/>
                                    </f7-list-item>                                    
                                </f7-list>
                            </f7-block>
                            <f7-block v-else style="height: calc(100% - 100px)">
                                <span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
                                    <span class="text-align-center">
                                        <span class="display-block text-align-center">
                                            <f7-icon material="person" style="font-size:100px;color:#eee;"></f7-icon>
                                            <span class="display-block">It's a little quiet here</span>
                                        </span>
                                    </span>
                                </span>
                            </f7-block>
                        </f7-page>
                    </f7-view>
                </f7-popup>                
            </f7-list>
        </f7-block>
        <f7-block v-if="searchResult.length > 0">
            <f7-chip v-for="(item, index) in searchResult" :key="index" deleteable @click="deleteParticipant(index, item)">
                <span slot="text">{{ item.status == 'approved' ? item.fullname : randomName() }}</span>
                <img slot="media" :src="item.status == 'approved' && item.media != null ? item.media.url.small : require('../assets/no-profile-photo.png')"/>
            </f7-chip>
        </f7-block>
        <br>
        <f7-button @click="doSubmit" fill-ios round-ios color="white" icon-f7="arrow_right" class="gradient-button-blue text-align-left" large>{{ formType }} Tombol Panik</f7-button>
    </f7-page>    
</template>
<script>
import { mapGetters } from 'vuex';
import { setTimeout } from 'timers';
import { parseError } from '../js/utils';
export default {
    name: 'PanicGroupForm',
	data(){
        return{
            formType: 'Buat',
            groupForm: {
                id: null,
                panic_group: '',
                name: '',
                description: '',
                participants: [],
                live_location: false,
                media: null
            },
            media: null,
            searchResult: []
        }
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('panic', [
            'panic',
            'participant'
        ])
    },
    methods: {
        randomName(){
            const self = this;
            const app = self.$f7;

            return app.utils.id('xxxx-xxxx').toUpperCase();
        },
        onPageBeforeIn(){
            const self = this;
            const app = self.$f7;

            if(self.$f7route.params && self.$f7route.params.id){
                self.formType = 'Ubah';
                self.groupForm.id = self.$f7route.params.id;
                
                app.preloader.show('green');

                self.$store.dispatch('panic/viewPanic', {
                    id: self.groupForm.id,
                    only: 'id,panic_group,name,description,media,author.id,author.phone,author.profile.fullname,author.profile.initial,author.profile.media,total_participant,total_comment,total_report,participants.id,participants.status,participants.user.id,participants.user.profile.fullname,participants.user.profile.media'
                }).then(()=>{

                    self.groupForm.panic_group = self.panic.panic_group;
                    self.groupForm.name = self.panic.name;
                    self.groupForm.description = self.panic.description;
                    self.groupForm.live_location = self.panic.live_location;
                    self.groupForm.media = self.panic.media != null ? self.panic.media.id : null;
                    
                    if(self.panic.participants.length > 0){
                        for(const x of self.panic.participants){
                            self.groupForm.participants.push(x.user.id);
                            self.searchResult.push({
                                id: x.user.id,
                                fullname: x.user.profile.fullname,
                                media: x.user.profile.media,
                                status: x.status
                            });
                        }
                    }

                    app.preloader.hide();
                });

            }
        },
        onPageBeforeOut(page){
            const self = this;

            if(page.detail.name == 'panicgroupform'){
				self.groupForm = {
                    name: '',
                    description: '',
                    participants: [],
                    live_location: false,
                    media: null
                };
                self.searchResult = [];
                self.formType = 'Tambah';
			}

            if (self.participantPopup) self.participantPopup.destroy();
        },
        doSubmit(){
            const self = this;
            const app = self.$f7;

            if(self.groupForm.description.length == 0){
				self.groupForm.description = null;
            }

            if(self.groupForm.name.length == 0){
				app.dialog.alert('Silahkan isi nama panik', 'RingSatu');
                return false;
            }else if(self.groupForm.name.length > 100){
				app.dialog.alert('Panjang nama tombol panik maksimal 100 karakter', 'RingSatu');
                return false;
            }else if(self.groupForm.participants.length == 0){
				app.dialog.alert('Silahkan pilih anggota group terlebih dahulu', 'RingSatu');
                return false;
            }

            app.preloader.show('green');

			let action = '';
			let params = {};

			if(self.formType == 'Ubah'){
				params.id = self.$f7route.params.id;
				action = 'panic/editPanic';
			}else{
                action = 'panic/createPanic';
            }

            if(self.groupForm.participants.indexOf(self.user.id) == -1){
                self.groupForm.participants.unshift(self.user.id);
            }

            params.group = self.groupForm.panic_group;
            params.name = self.groupForm.name;
            params.description = self.groupForm.description;
            params.live_location = self.groupForm.live_location;
            params.participants = self.groupForm.participants;
            params.media = self.groupForm.media; 

            self.$store.dispatch(action, params).then((response) => {
				app.preloader.hide();

				if('errors' in response){
					let error = parseError(response.errors);
					app.dialog.alert(error.messages, 'RingSatu');
					return false;
				}else{
					self.$f7router.back({
						ignoreCache: true
					});
				}
			});
        },
        deleteParticipant(index, participant){
            const self = this;
            const app = self.$f7;

            app.dialog.alert('Hapus anggota group?', 'RingSatu', function(){
                if(participant.id == null){
                    self.groupForm.participants.splice(index, 1);
                    self.searchResult.splice(index, 1);
                }else{
                    app.preloader.show('green');
                    self.$store.dispatch('panic/deleteParticipant', {
                        id: self.panic.id,
                        user: participant.id,
                        status: 'rejected',
                        only: 'id,panic_group,name,description,media,author.id,author.phone,author.profile.fullname,author.profile.initial,author.profile.media,total_participant,total_comment,total_report,participants.id,participants.status,participants.user.id,participants.user.profile.fullname,participants.user.profile.media'
                    }).then(()=>{
                        app.preloader.hide();
                    });
                }
            });
        },
        handleLive(value){
            const self = this;
            self.groupForm.live_location = value;
        },
        addParticipant(participant){
            const self = this;
            const app = self.$f7;

            if(self.groupForm.participants.indexOf(participant.id) == -1){
                self.groupForm.participants.push(participant.id);
                self.searchResult.push({
                    id: null,
                    fullname: participant.profile.fullname,
                    media: participant.profile.media
                });
            }

            var participantPopup = app.popup.get('.participant-popup');
            if(participantPopup){
                participantPopup.close();
            }
        },
        participantPopupOpen(){
            const self = this;
            const app = self.$f7;
        },
        participantPopupClose(e){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('panic/resetParticipant');
        },
        handleParticipantSearch(sb, query, prevQuery){
            const self = this;
            const app = self.$f7;

            if(query.length >= 10){
                self.$store.dispatch('panic/getParticipant', {
                    phone: query,
                    invitable: true
                }).then((response)=>{
                    if('errors' in response){
                        self.$store.dispatch('panic/resetParticipant');
                    }
                });
            }
        },
        handleUpload(){

            const self = this;
            const app = self.$f7;
            const $$ = self.$$;
            const $el = self.$el;

            var ac = app.actions.create({
                buttons: [
                    {
                        text: 'Kamera', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.CAMERA)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/panic/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                        .then(function (r) {
                                            var response = JSON.parse(r.response);
                                            self.groupForm.media = response.data.media.id
                                            self.media = response.data.media;
                                            app.preloader.hide();
                                        })
                                        .catch(function (e) {
                                            app.preloader.hide();
                                        });
                                });
                        }
                    },
                    {
                        text: 'Galeri', onClick: function () {
                            app.methods.takePicture(Camera.PictureSourceType.PHOTOLIBRARY)
                                .then(function (bannerImagePath) {
                                    app.preloader.show('green');

                                    var payload = {url: '/media/tmp', imagePath: bannerImagePath, key: 'media', method: 'POST'};

                                    if(self.formType == 'Ubah'){
                                        payload = {url: '/media/panic/'+self.$f7route.params.id, imagePath: bannerImagePath, key: 'media', method: 'POST'};
                                    }

                                    app.methods.storePicture(payload)
                                    .then(function (r) {
                                        var response = JSON.parse(r.response);
                                        self.groupForm.media = response.data.media.id
                                        self.media = response.data.media;
                                        app.preloader.hide();
                                    })
                                    .catch(function (e) {
                                        app.preloader.hide();
                                    });

                                });
                        }
                    },
                    {
                        text: 'Batal', color: 'red'
                    }
                ]
            });

            ac.open();
        }
    }
}
</script>
